// ./server/func_handlerequest.go.sh ./requests.txt
// MACHINE GENERATED BY THE COMMAND ABOVE; DO NOT EDIT

package nslcd_server

import (
	"fmt"
	"io"
	"os"
	s "syscall"

	p "lukeshu.com/git/go/libnslcd.git/proto"
)

var sensitive = "<omitted-from-log>"

// Handle a request to nslcd
func HandleRequest(backend Backend, in io.Reader, out io.Writer, cred s.Ucred) (err error) {
	err = nil
	defer func() {
		if r := recover(); r != nil {
			switch r := r.(type) {
			case error:
				err = r
			default:
				panic(r)
			}
		}
	}()
	handleRequest(backend, in, out, cred)
	return
}

func handleRequest(backend Backend, in io.Reader, out io.Writer, cred s.Ucred) {
	var version int32
	p.Read(in, &version)
	if version != p.NSLCD_VERSION {
		panic(p.NslcdError(fmt.Sprintf("Version mismatch: server=%#08x client=%#08x", p.NSLCD_VERSION, version)))
	}
	var action int32
	p.Read(in, &action)

	ch := make(chan interface{})
	switch action {
	case p.NSLCD_ACTION_CONFIG_GET:
		var req p.Request_Config_Get
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Config_Get(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_ALIAS_BYNAME:
		var req p.Request_Alias_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Alias_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_ALIAS_ALL:
		var req p.Request_Alias_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Alias_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_ETHER_BYNAME:
		var req p.Request_Ether_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Ether_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_ETHER_BYETHER:
		var req p.Request_Ether_ByEther
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Ether_ByEther(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_ETHER_ALL:
		var req p.Request_Ether_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Ether_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_GROUP_BYNAME:
		var req p.Request_Group_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Group_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_GROUP_BYGID:
		var req p.Request_Group_ByGid
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Group_ByGid(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_GROUP_BYMEMBER:
		var req p.Request_Group_ByMember
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Group_ByMember(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_GROUP_ALL:
		var req p.Request_Group_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Group_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_HOST_BYNAME:
		var req p.Request_Host_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Host_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_HOST_BYADDR:
		var req p.Request_Host_ByAddr
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Host_ByAddr(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_HOST_ALL:
		var req p.Request_Host_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Host_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_NETGROUP_BYNAME:
		var req p.Request_Netgroup_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Netgroup_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_NETGROUP_ALL:
		var req p.Request_Netgroup_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Netgroup_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_NETWORK_BYNAME:
		var req p.Request_Network_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Network_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_NETWORK_BYADDR:
		var req p.Request_Network_ByAddr
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Network_ByAddr(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_NETWORK_ALL:
		var req p.Request_Network_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Network_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PASSWD_BYNAME:
		var req p.Request_Passwd_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Passwd_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PASSWD_BYUID:
		var req p.Request_Passwd_ByUID
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Passwd_ByUID(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PASSWD_ALL:
		var req p.Request_Passwd_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Passwd_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PROTOCOL_BYNAME:
		var req p.Request_Protocol_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Protocol_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PROTOCOL_BYNUMBER:
		var req p.Request_Protocol_ByNumber
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Protocol_ByNumber(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PROTOCOL_ALL:
		var req p.Request_Protocol_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Protocol_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_RPC_BYNAME:
		var req p.Request_RPC_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.RPC_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_RPC_BYNUMBER:
		var req p.Request_RPC_ByNumber
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.RPC_ByNumber(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_RPC_ALL:
		var req p.Request_RPC_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.RPC_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_SERVICE_BYNAME:
		var req p.Request_Service_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Service_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_SERVICE_BYNUMBER:
		var req p.Request_Service_ByNumber
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Service_ByNumber(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_SERVICE_ALL:
		var req p.Request_Service_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Service_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_SHADOW_BYNAME:
		var req p.Request_Shadow_ByName
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Shadow_ByName(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_SHADOW_ALL:
		var req p.Request_Shadow_All
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.Shadow_All(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PAM_AUTHENTICATION:
		var req p.Request_PAM_Authentication
		p.Read(in, &req)
		_req := req
		_req.Password = sensitive
		fmt.Fprintf(os.Stderr, "Request: %#v\n", _req)
		_ch := backend.PAM_Authentication(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PAM_AUTHORIZATION:
		var req p.Request_PAM_Authorization
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.PAM_Authorization(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PAM_SESSIONOPEN:
		var req p.Request_PAM_SessionOpen
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.PAM_SessionOpen(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PAM_SESSIONCLOSE:
		var req p.Request_PAM_SessionClose
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.PAM_SessionClose(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_PAM_PWMOD:
		var req p.Request_PAM_PwMod
		p.Read(in, &req)
		_req := req
		if len(_req.OldPassword) > 0 {
			_req.OldPassword = sensitive
		}
		_req.NewPassword = sensitive
		fmt.Fprintf(os.Stderr, "Request: %#v\n", _req)
		_ch := backend.PAM_PwMod(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	case p.NSLCD_ACTION_USERMOD:
		var req p.Request_UserMod
		p.Read(in, &req)
		fmt.Fprintf(os.Stderr, "Request: %#v\n", req)
		_ch := backend.UserMod(cred, req)
		go func() {
			defer close(ch)
			for obj := range _ch {
				ch <- obj
			}
		}()
	default:
		close(ch)
		panic(p.NslcdError(fmt.Sprintf("Unknown request action: %#08x", action)))
	}
	p.Write(out, p.NSLCD_VERSION)
	p.Write(out, action)

	for result := range ch {
		p.Write(out, p.NSLCD_RESULT_BEGIN)
		p.Write(out, result)
	}
	p.Write(out, p.NSLCD_RESULT_END)
}
